/*
An index in SQL Server is similar to an index in a book
* It maps Values to Locations to make it easier to find information
* An index can be clustered (grouped and ordered) or nonclustered
* * A table can only have one clustered index
* * *  The data in the table IS the clustered index
* * * The data in the table is physically ordered by the clustered index
* * A table can have many nonclustered indexes
* * * A nonclustered index will contain pointers (RowIDs or Clustered Keys)
* * * The pointers tell SQL Server where to find the information in the table

A statistic in SQL Server contains information about columns
* Actual values contained in the column
* Cardinality (how many unique values are contained in the index/column)
* Distribution (how the individual values are spread throughout the table)

Indexes and Statistics combine to make it easier for the query optimizer
to do its job. Without them, it has a much harder time, which can help
explain the performance impact of different temporary items
*/
