/*

Location: TempDB
Location scope:  @Local
                Local are accessible from the connection that created them
Time scope: Exist until end of current transaction
Indexable: Yes (Clustered only)
Copy of data: Yes
Modifiable: Yes, modifies copy of data

*/

-- Basic Table Variable usage

/*
declare @JK_Test_Table_Variable TABLE (
       myIntKey int PRIMARY KEY CLUSTERED,
       myVarchar varchar(10) not null
);

insert into @JK_Test_Table_Variable (myIntKey, myVarchar) 
values (1, 'A'),
       (2, 'B'),
       (3, 'A'),
       (4, 'C');

select *
  from @JK_Test_Table_Variable
where myVarchar = 'A';

create nonclustered index JK_Test_Table_Variable_SIDX_1 on @JK_Test_Table_Variable (
       myVarchar asc
);
*/

-- Table Variables only exist during this transaction

/*
declare @@JK_Test_Table_Variable TABLE (
       myIntKey int PRIMARY KEY CLUSTERED,
       myVarchar varchar(10) not null
);
go

insert into @@JK_Test_Table_Variable (myIntKey, myVarchar) 
values (1, 'A'),
       (2, 'B'),
       (3, 'A'),
       (4, 'C');
go
*/

-- Table variables are updateable

/*
declare @JK_Test_Table_Variable TABLE (
       myIntKey int PRIMARY KEY CLUSTERED,
       myVarchar varchar(10) not null
);

insert into @JK_Test_Table_Variable (myIntKey, myVarchar) 
values (1, 'A'),
       (2, 'B'),
       (3, 'A'),
       (4, 'C');

update tgt
   set MyVarchar = 'D'
 from @JK_Test_Table_Variable tgt
where myIntKey = 4;

select *
  from @JK_Test_Table_Variable;
*/

-- Table variables are independent of the data that created them

/*
declare @JK_Test_Table_Variable TABLE (
       myIntKey int PRIMARY KEY CLUSTERED,
       myVarchar varchar(10) not null
);

insert into @JK_Test_Table_Variable
select *
  from dbo.JK_Temp_Stuff_Test_Table;

update @JK_Test_Table_Variable
   set myVarchar = 'Whooo';

select * from @JK_Test_Table_Variable;
select * from dbo.JK_Temp_Stuff_Test_Table;
*/