/*

Location: System tables of the database it is created in
Location scope: Global (Accessible from anywhere)                
Time scope: Exist until dropped
Indexable: Yes (Clustered, then Nonclustered)
Copy of data: No
Modifiable: Yes, modifies underlying data

*/

-- Basic view creation

/*
create view dbo.JK_Test_View as (
       select myIntKey
            , myVarchar
            , '42' as [Answer to Everything]
         from dbo.JK_Temp_Stuff_Test_Table
);
*/

-- Selecting from a view

/*
select *
  from dbo.JK_Test_View;
*/

-- Inserting into a view

/*
insert into dbo.JK_Test_View (myIntKey, myVarchar)
values (7, 'View Test');

select *
  from dbo.JK_Test_View;
*/

-- View updates with underlying table

/*
insert into dbo.JK_Temp_Stuff_Test_Table (myIntKey, myVarchar)
values (12, 'View Test2');

select *
  from dbo.JK_Test_View;
*/

-- Updating multi-table views is weird

/*
create view dbo.JK_Test_View_2 as (
       select a.myIntKey
            , a.myVarchar
            , b.myOtherVarchar
         from dbo.JK_Temp_Stuff_Test_Table a
        inner join dbo.JK_Temp_Stuff_Test_Table_2 b
           on a.myIntKey = b.myIntKey        
);
*/

/*
update dbo.JK_Test_View_2
   set myIntKey = 9;

select *
  from dbo.JK_Test_View_2;

select *
  from dbo.JK_Temp_Stuff_Test_Table;

select *
  from dbo.JK_Temp_Stuff_Test_Table_2;

update dbo.JK_Temp_Stuff_Test_Table set myIntKey = 5 where myIntKey = 9;
*/

/*
update dbo.JK_Test_View_2
   set myIntKey = 9
     , myOtherVarchar = 'Pancake';

select *
  from dbo.JK_Test_View_2;

select *
  from dbo.JK_Temp_Stuff_Test_Table;

select *
  from dbo.JK_Temp_Stuff_Test_Table_2;
*/

-- Cleanup
/*
drop view dbo.JK_Test_View;
drop view dbo.JK_Test_View_2;
delete from dbo.JK_Temp_Stuff_Test_Table where myIntKey in (7,12);
update dbo.JK_Temp_Stuff_Test_Table set myIntKey = 5;
update dbo.JK_Temp_Stuff_Test_Table_2 set myOtherVarchar = 'Waffle';
*/